/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

#ifdef ENABLE_CHECKING
  memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
  memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
#endif

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 41:  /* jump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 39:  /* *call_value_indirect */
    case 38:  /* *call_value */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 37:  /* *call */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 36:  /* *bleu */
    case 35:  /* *bgeu */
    case 34:  /* *ble */
    case 33:  /* *bge */
    case 32:  /* *bgtu */
    case 31:  /* *bgt */
    case 30:  /* *bltu */
    case 29:  /* *blt */
    case 28:  /* *beq */
    case 27:  /* *bne */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 26:  /* *cmpsi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 25:  /* *movhi */
    case 24:  /* *movqi */
    case 19:  /* *movsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 18:  /* movsi_pop */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 0));
      break;

    case 40:  /* indirect_jump */
    case 17:  /* movsi_push */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 23:  /* extendhisi2 */
    case 22:  /* extendqisi2 */
    case 21:  /* zero_extendhisi2 */
    case 20:  /* zero_extendqisi2 */
    case 10:  /* one_cmplsi2 */
    case 9:  /* negsi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 16:  /* lshrsi3 */
    case 15:  /* ashrsi3 */
    case 14:  /* ashlsi3 */
    case 13:  /* iorsi3 */
    case 12:  /* xorsi3 */
    case 11:  /* andsi3 */
    case 8:  /* umodsi3 */
    case 7:  /* modsi3 */
    case 6:  /* udivsi3 */
    case 5:  /* divsi3 */
    case 4:  /* mulsi3 */
    case 3:  /* subsi3 */
    case 2:  /* addsi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 42:  /* returner */
    case 1:  /* nop */
      break;

    }
}
