/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc/config/moxie/moxie.md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "tree.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "tm_p.h"
#include "function.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "hard-reg-set.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"

static inline int
moxie_general_movsrc_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 29 "../../gcc/config/moxie/predicates.md"
{
  /* Any (MEM LABEL_REF) is OK.  That is a pc-relative load.  */
  if (MEM_P (op) && GET_CODE (XEXP (op, 0)) == LABEL_REF)
    return 1;

  if (MEM_P (op)
      && GET_CODE (XEXP (op, 0)) == PLUS
      && GET_CODE (XEXP (XEXP (op, 0), 0)) == REG
      && GET_CODE (XEXP (XEXP (op, 0), 1)) == CONST)
    return 1;

  return general_operand (op, mode);
}

int
moxie_general_movsrc_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case MEM:
    case CONST_INT:
    case REG:
    case SUBREG:
    case SYMBOL_REF:
    case LABEL_REF:
    case CONST:
      break;
    default:
      return false;
    }
  return 
(moxie_general_movsrc_operand_1 (op, mode));
}

int
moxie_add_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
(mode == VOIDmode || GET_MODE (op) == mode))) || ((GET_CODE (op) == CONST_INT) && (
#line 48 "../../gcc/config/moxie/predicates.md"
(IN_RANGE (INTVAL (op), -255, 255))));
}

int
moxie_sub_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
(mode == VOIDmode || GET_MODE (op) == mode))) || ((GET_CODE (op) == CONST_INT) && (
#line 55 "../../gcc/config/moxie/predicates.md"
(IN_RANGE (INTVAL (op), 0, 255))));
}

enum constraint_num
lookup_constraint (const char *str)
{
  switch (str[0])
    {
    case 'A':
      return CONSTRAINT_A;
    case 'B':
      return CONSTRAINT_B;
    case 'I':
      return CONSTRAINT_I;
    case 'N':
      return CONSTRAINT_N;
    case 'O':
      return CONSTRAINT_O;
    case 'W':
      return CONSTRAINT_W;
    default: break;
    }
  return CONSTRAINT__UNKNOWN;
}

bool
constraint_satisfied_p (rtx op, enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_A: return satisfies_constraint_A (op);
    case CONSTRAINT_B: return satisfies_constraint_B (op);
    case CONSTRAINT_W: return satisfies_constraint_W (op);
    case CONSTRAINT_O: return satisfies_constraint_O (op);
    case CONSTRAINT_I: return satisfies_constraint_I (op);
    case CONSTRAINT_N: return satisfies_constraint_N (op);
    default: break;
    }
  return false;
}

bool
insn_const_int_ok_for_constraint (HOST_WIDE_INT ival, enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_O:
      return 
#line 46 "../../gcc/config/moxie/constraints.md"
(ival == 0);

    case CONSTRAINT_I:
      return 
#line 51 "../../gcc/config/moxie/constraints.md"
(ival >= 0 && ival <= 255);

    case CONSTRAINT_N:
      return 
#line 56 "../../gcc/config/moxie/constraints.md"
(ival >= -255 && ival <= 0);

    default: break;
    }
  return false;
}

